/* gamemain2.c */
#include<scenario.h>
#include<screen.h>
#include<gameio.h>
#include<walls.h>
#include<stdio.h>
#include<enemy.h>
#include<movingobjectmanager.h>
#ifdef DEBUG
#include<log.h>
#endif

#define OBJNUM 4
#define MOBJNUM 3
#define EVNUM 98

object* objp[OBJNUM];
movingobject* mobjp[MOBJNUM];
movingobject* mobjp2[MOBJNUM];
movingobject* mobjp3[MOBJNUM];
movingobject* mobjp4[MOBJNUM];
event* ev[EVNUM];
vector2 mypos;
int isfire;
int score;
static int speedlevel=8;
static int speedlevel2=8;
static int speedlevel3=1;
static int item = 0;
static int HP=100;

void onestepb(movingobject* mobj){
  vec2add(&(mobj->pos), &(mobj->vel));
}

void dispb(movingobject* mobj){
  putobject(*(mobj->obj), mobj->id, mobj->pos.x, mobj->pos.y);
}

void dispm(movingobject* mobj){
  putobject(*(mobj->obj), 0, mobj->pos.x, mobj->pos.y);
}

int bomba(movingobject* mobj){
  score+=50;
  return 1;
}




void initobjects(void){
  objp[0] = newobject(1,1,"x");
  objp[1] = newobject(3,2," ^ =o=");
}

void initmovingobjects(void){
  mobjp[0] = newenemy();
  mobjp[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");
  mobjp[2] = newmovingobject(&objp[1], NULL, dispm, bomba, "me");
}
void initmovingobjects2(void){
  mobjp2[0] = maynewenemy();
  mobjp2[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");
  mobjp2[2] = newmovingobject(&objp[1], NULL, dispm, bomba, "me");
}
void initmovingobjects3(void){
  mobjp3[0] = maynewenemy2();
  mobjp3[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");
  mobjp3[2] = newmovingobject(&objp[1], NULL, dispm, bomba, "me");
}
void initmovingobjects4(void){
  mobjp4[0] = newenemy_chitose1();
  mobjp4[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");
  mobjp4[2] = newmovingobject(&objp[1], NULL, dispm, bomba, "me");
}

void setevents(void){
  int i;
  for(i=0;i<16;i++){
  ev[6*i+0] = newevent(40*i+5, makevector2(10,2),makevector2(0.1,0.1), mobjp[0],"plus0");
  ev[6*i+1] = newevent(40*i+15, makevector2(25,2),makevector2(0.2,0.1), mobjp2[0],"plus3");
  ev[6*i+2] = newevent(40*i+16, makevector2(25,6),makevector2(0,0.3), mobjp3[0],"plus4");
  ev[6*i+3] = newevent(40*i+25, makevector2(15,8),makevector2(0,0.2), mobjp4[0],"plus0");
  ev[6*i+4] = newevent(40*i+35, makevector2(8,5),makevector2(-0.2,0.15), mobjp2[0],"plus4");
  ev[6*i+5] = newevent(40*i+36, makevector2(8,9),makevector2(0,0.3), mobjp3[0],"plus4");

  }
  ev[97] = newevent(1000000, 
                   makevector2(30,1),makevector2(0,1), mobjp[0],"dummy");
  for(i=0;i<EVNUM;i++){
    addevent(ev[i]);
  }
  resetmark();
}

void init(void){
  initscreen();
  initwalls();
  initmom();
  initobjects();
  initmovingobjects();
  initmovingobjects2();
  initmovingobjects3();
  initmovingobjects4();
  initscenario();
  setevents();
}


void getstate(vector2* ret, int* isfire){
  static vector2 pos = {SCREENWIDTH/2-1, SCREENHEIGHT-3}; 
  *isfire = 0;
  int time = 0;
  int in = gameioread();
  switch(in){
  case 'k':
  case 'K':
    pos.x++;
    break;
  case 'j':
  case 'J':
    pos.x--;
    break;
  case 'i':
  case 'I':
    pos.y--;
    break;
  case 'm':
  case 'M':
    pos.y++;
    break;
  case ' ':
    *isfire = 1;
    break;
  case 'x':
  case 'X':
    speedlevel = 5;
    speedlevel3 = 2;
    break;
  case 'c':
  case 'C':
    speedlevel = speedlevel2;
    speedlevel3 = 1;
    break;
  } 
  *ret = pos;
}

void show(void){
  int x,y;
  for(y=0;y<SCREENHEIGHT;y++){
    for(x=0;x<SCREENWIDTH;x++){
      gameioput(x,y,dispbuffer[SCREENWIDTH*y+x]);
    }
  }
  gameiorefresh();
}

void gameloop(void){ 
  int time = 0;
  int spchange = gameioread();
  vector2 tmpv;
  event* e = getnextevent();
  while(1){
    gameiousleep(30000);
    if(time%speedlevel == 0){
      scrollwall();
      while(e!= NULL && e->time*speedlevel < time){
        addmo(e->mobj, e->pos, e->vel);
        e = getnextevent();
      }
      score++;
      if(speedlevel == 5)score++;
    }

    if(score>=2000)break;

    getstate(&mypos, &isfire);
    gameioput(SCREENWIDTH+3,1,'0'+(int)mypos.x/10);
    gameioput(SCREENWIDTH+4,1,'0'+(int)mypos.x%10);
    gameioput(SCREENWIDTH+6,1,'0'+(int)mypos.y/10);
    gameioput(SCREENWIDTH+7,1,'0'+(int)mypos.y%10);

    gameioput(SCREENWIDTH+5,29,'s');
    gameioput(SCREENWIDTH+6,29,'p');
    gameioput(SCREENWIDTH+7,29,'e');
    gameioput(SCREENWIDTH+8,29,'e');
    gameioput(SCREENWIDTH+9,29,'d');
    gameioput(SCREENWIDTH+10,29,'l');
    gameioput(SCREENWIDTH+11,29,'e');
    gameioput(SCREENWIDTH+12,29,'v');
    gameioput(SCREENWIDTH+13,29,'e');
    gameioput(SCREENWIDTH+14,29,'l');
    gameioput(SCREENWIDTH+16,29,'0'+(int)speedlevel3);

    gameioput(SCREENWIDTH+5,31,'s');
    gameioput(SCREENWIDTH+6,31,'c');
    gameioput(SCREENWIDTH+7,31,'o');
    gameioput(SCREENWIDTH+8,31,'r');
    gameioput(SCREENWIDTH+9,31,'e');

    gameioput(SCREENWIDTH+12,31,'0'+(int)score/1000);
    gameioput(SCREENWIDTH+13,31,'0'+(int)(score%1000)/100);
    gameioput(SCREENWIDTH+14,31,'0'+(int)(score%100)/10);
    gameioput(SCREENWIDTH+15,31,'0'+(int)score%10);
    gameioput(SCREENWIDTH+5,33,'H');
    gameioput(SCREENWIDTH+6,33,'P');
    gameioput(SCREENWIDTH+8,33,'0'+(int)HP/1000);
    gameioput(SCREENWIDTH+9,33,'0'+(int)(HP%1000)/100);
    gameioput(SCREENWIDTH+10,33,'0'+(int)(HP%100)/10);
    gameioput(SCREENWIDTH+11,33,'0'+(int)HP%10);
			

    putwalls(SCREENHEIGHT);
    putmo();
    onestepmo();
    if(checkcollision(mypos, objp[1])==WALL){
      break;
    }
    if(checkcollision(mypos, objp[1])!=NONOBJ){
      HP--;
    }

    if(HP==0)break;

   

    if(isfire){
      tmpv = mypos;
      tmpv.x +=1;
      tmpv.y -=2;
      addmo(mobjp[1], tmpv, makevector2(0,-1));
    }
    mobjp[2]->pos = mypos;
    dispm(mobjp[2]);
    show();
    time++;
  }
}

int main(void){
  printf("シューティングゲームへようこそ！\n壁をよけて敵を倒しながら進んでね。\nHPが０になったり壁にあたるとゲーム終了だよ！\n\n~操作方法~\n上：Iキー　　下：Mキー　右：Kキー　左：Jキー\n加速：Xキー(ポイント２倍)　速度を戻す：Cキー\n弾丸をうつ：スペースキー\n\n");
    printf("準備はできましたか？\n　　　　returnを押してゲームスタート！");
    while(getchar()!='\n');
  
  gameioinit();
  gameioclear();
  init();
  
  score=0;
  gameloop();
  gameiopost();
  printf("score %d\n",score);
  if(score>=2000){
    printf("Game Clear!!\n 　　　  ∧＿∧\n　／＼ （　・∀・）／ヽ\n（ ●　と　　 　つ　● ）\n　＼/⊂、　 　 ノ　＼ノ\n　　　　 　し’\nまた遊んでね！\n");
  }
  else if(score>=1800){
    printf("惜しい！あともう一息！\n   ♪\n　　　∧__,,∧\n　ヽ(´・ω・`)ノ　♪\n♪　へ/　　/　♪\n　　　ヽノ\n　　　　＞\n　Fightだよ！");
  }
  else{
      printf("( ´,_ゝ`)＜君ならもっとやれるはずだ。\n");
    }
  
  return 0;
}
